diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-non-ht-dup-test.cc ns-3.43/src/wifi/test/wifi-non-ht-dup-test.cc
--- ns-3.42/src/wifi/test/wifi-non-ht-dup-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-non-ht-dup-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -52,7 +41,7 @@
 
 NS_LOG_COMPONENT_DEFINE("WifiNonHtDuplicateTest");
 
-constexpr uint32_t DEFAULT_FREQUENCY = 5180; // MHz
+constexpr MHz_u DEFAULT_FREQUENCY = 5180;
 
 /**
  * HE PHY used for testing MU-RTS/CTS.
@@ -205,12 +194,12 @@
 {
   public:
     /// A vector containing parameters per STA: the standard, the center frequency and the P20 index
-    using StasParams = std::vector<std::tuple<WifiStandard, uint16_t, uint8_t>>;
+    using StasParams = std::vector<std::tuple<WifiStandard, MHz_u, uint8_t>>;
 
     /**
      * Constructor
      * \param apStandard the standard to use for the AP
-     * \param apFrequency the center frequency of the AP (in MHz)
+     * \param apFrequency the center frequency of the AP
      * \param apP20Index the index of the primary 20 MHz channel of the AP
      * \param stasParams the parameters of the STAs (\see StasParams)
      * \param per20MhzInterference flags per 20 MHz subchannel whether an interference should be
@@ -218,7 +207,7 @@
      * interference.
      */
     TestNonHtDuplicatePhyReception(WifiStandard apStandard,
-                                   uint16_t apFrequency,
+                                   MHz_u apFrequency,
                                    uint8_t apP20Index,
                                    StasParams stasParams,
                                    std::vector<bool> per20MhzInterference = {});
@@ -264,9 +253,9 @@
 
     /**
      * Send non-HT duplicate PPDU function
-     * \param channelWidth the channel width to use to transmit the non-HT PPDU (in MHz)
+     * \param channelWidth the channel width to use to transmit the non-HT PPDU
      */
-    void SendNonHtDuplicatePpdu(uint16_t channelWidth);
+    void SendNonHtDuplicatePpdu(MHz_u channelWidth);
 
     /**
      * Generate interference function
@@ -284,7 +273,7 @@
     void StopInterference(Ptr<WaveformGenerator> interferer);
 
     WifiStandard m_apStandard; ///< the standard to use for the AP
-    uint16_t m_apFrequency;    ///< the center frequency of the AP (in MHz)
+    MHz_u m_apFrequency;       ///< the center frequency of the AP
     uint8_t m_apP20Index;      ///< the index of the primary 20 MHz channel of the AP
     StasParams m_stasParams;   ///< the parameters of the STAs
     std::vector<bool>
@@ -303,7 +292,7 @@
 
 TestNonHtDuplicatePhyReception::TestNonHtDuplicatePhyReception(
     WifiStandard apStandard,
-    uint16_t apFrequency,
+    MHz_u apFrequency,
     uint8_t apP20Index,
     StasParams stasParams,
     std::vector<bool> per20MhzInterference)
@@ -333,13 +322,13 @@
 }
 
 void
-TestNonHtDuplicatePhyReception::SendNonHtDuplicatePpdu(uint16_t channelWidth)
+TestNonHtDuplicatePhyReception::SendNonHtDuplicatePpdu(MHz_u channelWidth)
 {
     NS_LOG_FUNCTION(this << channelWidth);
     WifiTxVector txVector = WifiTxVector(OfdmPhy::GetOfdmRate24Mbps(),
                                          0,
                                          WIFI_PREAMBLE_LONG,
-                                         800,
+                                         NanoSeconds(800),
                                          1,
                                          1,
                                          0,
@@ -474,13 +463,13 @@
 
     if (!m_per20MhzInterference.empty())
     {
-        [[maybe_unused]] auto [channelNum, centerFreq, apChannelWidth, type, phyBand] =
-            (*WifiPhyOperatingChannel::FindFirst(0,
-                                                 m_apFrequency,
-                                                 0,
-                                                 m_apStandard,
-                                                 WIFI_PHY_BAND_5GHZ));
-        NS_ASSERT(m_per20MhzInterference.size() == (apChannelWidth / 20));
+        const auto& channelInfo = (*WifiPhyOperatingChannel::FindFirst(0,
+                                                                       m_apFrequency,
+                                                                       0,
+                                                                       m_apStandard,
+                                                                       WIFI_PHY_BAND_5GHZ));
+        [[maybe_unused]] const std::size_t num20MhzSubchannels = channelInfo.width / 20;
+        NS_ASSERT(m_per20MhzInterference.size() == num20MhzSubchannels);
         for (std::size_t i = 0; i < m_per20MhzInterference.size(); ++i)
         {
             auto interfererNode = CreateObject<Node>();
@@ -524,32 +513,34 @@
         phySta->AssignStreams(streamNumber);
     }
 
-    [[maybe_unused]] auto [apChannelNum, centerFreq, apChannelWidth, type, phyBand] =
-        (*WifiPhyOperatingChannel::FindFirst(0,
-                                             m_apFrequency,
-                                             0,
-                                             m_apStandard,
-                                             WIFI_PHY_BAND_5GHZ));
-    m_phyAp->SetOperatingChannel(
-        WifiPhy::ChannelTuple{apChannelNum, apChannelWidth, WIFI_PHY_BAND_5GHZ, m_apP20Index});
+    const auto& apchannelInfo = (*WifiPhyOperatingChannel::FindFirst(0,
+                                                                     m_apFrequency,
+                                                                     0,
+                                                                     m_apStandard,
+                                                                     WIFI_PHY_BAND_5GHZ));
+    m_phyAp->SetOperatingChannel(WifiPhy::ChannelTuple{apchannelInfo.number,
+                                                       apchannelInfo.width,
+                                                       WIFI_PHY_BAND_5GHZ,
+                                                       m_apP20Index});
 
     auto index = 0;
     for (const auto& [staStandard, staFrequency, staP20Index] : m_stasParams)
     {
-        [[maybe_unused]] auto [staChannelNum, centerFreq, staChannelWidth, type, phyBand] =
-            (*WifiPhyOperatingChannel::FindFirst(0,
-                                                 staFrequency,
-                                                 0,
-                                                 staStandard,
-                                                 WIFI_PHY_BAND_5GHZ));
-        m_phyStas.at(index++)->SetOperatingChannel(
-            WifiPhy::ChannelTuple{staChannelNum, staChannelWidth, WIFI_PHY_BAND_5GHZ, staP20Index});
+        const auto& stachannelInfo = (*WifiPhyOperatingChannel::FindFirst(0,
+                                                                          staFrequency,
+                                                                          0,
+                                                                          staStandard,
+                                                                          WIFI_PHY_BAND_5GHZ));
+        m_phyStas.at(index++)->SetOperatingChannel(WifiPhy::ChannelTuple{stachannelInfo.number,
+                                                                         stachannelInfo.width,
+                                                                         WIFI_PHY_BAND_5GHZ,
+                                                                         staP20Index});
     }
 
     index = 0;
     const auto minApCenterFrequency =
         m_phyAp->GetFrequency() - (m_phyAp->GetChannelWidth() / 2) + (20 / 2);
-    for (auto channelWidth = 20; channelWidth <= apChannelWidth; channelWidth *= 2, ++index)
+    for (auto channelWidth = 20; channelWidth <= apchannelInfo.width; channelWidth *= 2, ++index)
     {
         if (!m_phyInterferers.empty())
         {
@@ -567,8 +558,8 @@
                 bands.push_back(bandInfo);
                 auto spectrumInterference = Create<SpectrumModel>(bands);
                 auto interferencePsd = Create<SpectrumValue>(spectrumInterference);
-                auto interferencePower = 0.005; // in watts (designed to make PHY headers reception
-                                                // successful but payload reception fail)
+                Watt_u interferencePower = 0.005; // designed to make PHY headers reception
+                                                  // successful but payload reception fail
                 *interferencePsd = interferencePower / 10e6;
                 Simulator::Schedule(Seconds(index),
                                     &TestNonHtDuplicatePhyReception::GenerateInterference,
@@ -635,7 +626,7 @@
     /// Information about CTS responses to expect in the test
     struct CtsTxInfos
     {
-        uint16_t bw{20};     ///< the width in MHz of the CTS response
+        MHz_u bw{20};        ///< the width of the CTS response
         bool discard{false}; ///< flag whether the CTS response shall be discarded
     };
 
@@ -702,7 +693,7 @@
     std::size_t m_countStaRxCtsFailure; ///< count the number of unsuccessfully received CTS frames
                                         ///< by the non-participating STA
 
-    double m_stasTxPowerDbm; ///< TX power in dBm configured for the STAs
+    dBm_u m_stasTxPower; ///< TX power configured for the STAs
 };
 
 TestMultipleCtsResponsesFromMuRts::TestMultipleCtsResponsesFromMuRts(
@@ -713,7 +704,7 @@
       m_countApRxCtsFailure{0},
       m_countStaRxCtsSuccess{0},
       m_countStaRxCtsFailure{0},
-      m_stasTxPowerDbm(10.0)
+      m_stasTxPower(10.0)
 {
 }
 
@@ -757,7 +748,7 @@
         WifiTxVector(OfdmPhy::GetOfdmRate54Mbps(), // use less robust modulation for test purpose
                      0,
                      WIFI_PREAMBLE_LONG,
-                     800,
+                     NanoSeconds(800),
                      1,
                      1,
                      0,
@@ -797,7 +788,7 @@
     if (isAp)
     {
         NS_TEST_EXPECT_MSG_EQ_TOL(rxSignalInfo.rssi,
-                                  WToDbm(DbmToW(m_stasTxPowerDbm) * successfulCtsInfos.size()),
+                                  WToDbm(DbmToW(m_stasTxPower) * successfulCtsInfos.size()),
                                   0.1,
                                   "RX power is not correct!");
     }
@@ -899,8 +890,9 @@
                          m_ctsTxInfosPerSta.cend(),
                          [](const auto& lhs, const auto& rhs) { return lhs.bw < rhs.bw; })
             ->bw;
-    auto apChannelNum = std::get<0>(
-        *WifiPhyOperatingChannel::FindFirst(0, 0, apBw, WIFI_STANDARD_80211ac, WIFI_PHY_BAND_5GHZ));
+    auto apChannelNum =
+        WifiPhyOperatingChannel::FindFirst(0, 0, apBw, WIFI_STANDARD_80211ac, WIFI_PHY_BAND_5GHZ)
+            ->number;
 
     m_phyAp->SetOperatingChannel(WifiPhy::ChannelTuple{apChannelNum, apBw, WIFI_PHY_BAND_5GHZ, 0});
 
@@ -926,15 +918,15 @@
         phySta->AddChannel(spectrumChannel);
         phySta->ConfigureStandard(WIFI_STANDARD_80211ax);
         phySta->AssignStreams(streamNumber);
-        phySta->SetTxPowerStart(m_stasTxPowerDbm);
-        phySta->SetTxPowerEnd(m_stasTxPowerDbm);
+        phySta->SetTxPowerStart(m_stasTxPower);
+        phySta->SetTxPowerEnd(m_stasTxPower);
 
-        auto channelNum =
-            std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                            0,
-                                                            m_ctsTxInfosPerSta.at(i).bw,
-                                                            WIFI_STANDARD_80211ac,
-                                                            WIFI_PHY_BAND_5GHZ));
+        auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                             0,
+                                                             m_ctsTxInfosPerSta.at(i).bw,
+                                                             WIFI_STANDARD_80211ac,
+                                                             WIFI_PHY_BAND_5GHZ)
+                              ->number;
 
         phySta->SetOperatingChannel(
             WifiPhy::ChannelTuple{channelNum, m_ctsTxInfosPerSta.at(i).bw, WIFI_PHY_BAND_5GHZ, 0});
